Scriptname CraftableCompassNeedlePosition extends ReferenceAlias 

Actor Property pPlayerRef Auto 

Armor Property CraftableCompass Auto
Armor Property CraftableCompassNeedle Auto
Armor Property CraftableCompassNeedleNE Auto
Armor Property CraftableCompassNeedleE Auto
Armor Property CraftableCompassNeedleSE Auto
Armor Property CraftableCompassNeedleS Auto
Armor Property CraftableCompassNeedleSW Auto
Armor Property CraftableCompassNeedleW Auto
Armor Property CraftableCompassNeedleNW Auto

FormList Property CompassNeedles Auto

GlobalVariable Property ZOffset Auto 
GlobalVariable Property CompassUpdate Auto
GlobalVariable Property UpdateToggle Auto
GlobalVariable Property CompassManualToggle Auto

Spell Property CompassHeading Auto
Spell Property CompassHeadingReset Auto
Spell Property CompassHeadingUpdate Auto
Spell Property CompassAutomaticUpdateToggle Auto
Spell Property CompassMaxNeedleToggle Auto

Static Property NorthMarker Auto

SoundCategory Property AudioCategorySFX Auto

Event OnItemAdded (Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
    If (akBaseItem == CraftableCompass)
        pPlayerRef.AddSpell(CompassHeading)
        pPlayerRef.AddSpell(CompassHeadingReset)
        pPlayerRef.AddSpell(CompassHeadingUpdate)
        pPlayerRef.AddSpell(CompassAutomaticUpdateToggle)
        pPlayerRef.AddSpell(CompassMaxNeedleToggle)
    Endif
EndEvent
     
    
Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
float ZOffsetA = ZOffset.getvalue()
float CompassUpdateA = CompassUpdate.getvalue()
ObjectReference NorthMarkerRef = Game.FindClosestReferenceOfTypeFromRef(NorthMarker, pPlayerRef, 5000.0)
float InteriorNorth = NorthMarkerRef.GetAngleZ()
float CurrentAngle = pPlayerRef.GetAngleZ()
float CompassManualToggleA = CompassManualToggle.GetValue()
    
If (akBaseObject == CraftableCompass)
    pPlayerRef.AddItem(CompassNeedles, 1, 1)
    UpdateToggle.SetValue(1)
    
    If (pPlayerRef.IsInInterior()) && (ZOffsetA == 0)
        CurrentAngle = (CurrentAngle - InteriorNorth)
    Else 
        CurrentAngle = (CurrentAngle - ZOffsetA)
    Endif

    If (CurrentAngle < 0)
        CurrentAngle = (CurrentAngle + 360)
    endif
    
    If (CurrentAngle >= 337.5) || (CurrentAngle < 22.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedle, false, true)
    ElseIf (CurrentAngle >= 22.5) && (CurrentAngle < 67.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleNE, false, true)
    ElseIf (CurrentAngle >= 67.5) && (CurrentAngle < 112.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleE, false, true)
    ElseIf (CurrentAngle >= 112.5) && (CurrentAngle < 157.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleSE, false, true)
    ElseIf (CurrentAngle >= 157.5) && (CurrentAngle < 202.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleS, false, true)
    ElseIf (CurrentAngle >= 202.5) && (CurrentAngle <247.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleSW, false, true)
    ElseIf (CurrentAngle >= 247.5) && (CurrentAngle < 292.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleW, false, true)
    ElseIf (CurrentAngle >= 292.5) && (CurrentAngle < 337.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleNW, false, true)
    EndIf 
    
    If (CompassManualToggleA == 1)
        RegisterForSingleUpdate(CompassUpdateA)
        AudioCategorySFX.Mute()
    Endif
EndIf
EndEvent

Event OnUpdate()
float ZOffsetA = ZOffset.getvalue()
float CompassUpdateA = CompassUpdate.getvalue()
ObjectReference NorthMarkerRef = Game.FindClosestReferenceOfTypeFromRef(NorthMarker, pPlayerRef, 25000.0)
float InteriorNorth = NorthMarkerRef.GetAngleZ()
float CurrentAngle = pPlayerRef.GetAngleZ()
float UpdateToggleA = UpdateToggle.GetValue()
float CompassManualToggleA = CompassManualToggle.GetValue()

If (UpdateToggleA == 1) && (CompassManualToggleA == 1)

    If (pPlayerRef.IsInInterior()) && (ZOffsetA == 0)
        CurrentAngle = (CurrentAngle - InteriorNorth)
        ;Debug.notification("Current Angle Is" +CurrentAngle)
    Else 
        CurrentAngle = (CurrentAngle - ZOffsetA)
        ;Debug.notification("Current Angle Is" +CurrentAngle)
    Endif

    If (CurrentAngle < 0)
            CurrentAngle = (CurrentAngle + 360)
        ;Debug.notification("Current Angle Is" +CurrentAngle)
    endif
        
    If (CurrentAngle >= 337.5) || (CurrentAngle < 22.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedle, false, true)
    ElseIf (CurrentAngle >= 22.5) && (CurrentAngle < 67.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleNE, false, true)
    ElseIf (CurrentAngle >= 67.5) && (CurrentAngle < 112.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleE, false, true)
    ElseIf (CurrentAngle >= 112.5) && (CurrentAngle < 157.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleSE, false, true)
    ElseIf (CurrentAngle >= 157.5) && (CurrentAngle < 202.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleS, false, true)
    ElseIf (CurrentAngle >= 202.5) && (CurrentAngle <247.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleSW, false, true)
    ElseIf (CurrentAngle >= 247.5) && (CurrentAngle < 292.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleW, false, true)
    ElseIf (CurrentAngle >= 292.5) && (CurrentAngle < 337.5)        
        pPlayerRef.EquipItem(CraftableCompassNeedleNW, false, true)
    EndIf 
EndIf
    RegisterForSingleUpdate(CompassUpdateA)
EndEvent

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
    
    If  (akBaseObject == CraftableCompass)
        AudioCategorySFX.Mute()
        UpdateToggle.SetValue(0)
        RegisterForSingleUpdate(0.25) ;interupts current update so UpdateToggle is correct
        pPlayerRef.RemoveItem(CompassNeedles, 1, 1)
        AudioCategorySFX.UnMute()
    EndIf   
EndEvent